% Gavin McNicol EPS 209 Matlab for Earth Scientists

% This function: 

% (1) Gets names of cow images in directory
% (2) Reads ROI file
% (3) Loops over all images:
%    (a) Reads image, converts to grayscale, applys median filter ([8,8])
%    (b) Finds edges of cows
%    (c) Filters using ROI
%    (d) Uses two IF statements to filter out:
%             (1) dark, nighttime images
%             (2) images with alot of edges (cows)
%    (e) Produces a vector of image names when MATLAB says there are cows
% (4) Creates vector of Days based upon image number and images per day
% (5) Plots the intensity of images and rangefilt intensity to show where
% the predition fails.


%% (1) Get names of cow images in directory
clear all; close all

% Get directory listing
listing = dir('*.jpg');
% Get number of files matching the query
nFiles = numel(listing);
% Print all the file names using a loop
for n=1:nFiles
fprintf([listing(n).name '\n']);
end

%% (2) 
% Load ROI file
ROI = imread('ROIwhole.png');

%% (3) Loop over all image files
for n=1:nFiles
    
  % Get image name
  imName = listing(n).name;
  
  % Read image
  I = imread(imName);

  % Convert image to black and white
  IBW = rgb2gray(I);
  m(n) = mean2(IBW);
  
  % Apply median filter to enhance edges
  IBW = medfilt2(IBW, [8,8]);
    
    % Find the edges of the cows
  % h  =  fspecial('sobel');
  % I2  =  imfilter(IBWroi,h);
  I3 = rangefilt(IBW); %really good results
             
  % Filter the image by the ROI
  IBWroi = immultiply(ROI,I3);
  figure, imshow(IBWroi);
%   figure, imshow(IBWroi)
  
% Use IF statements to filter images and return vector of cow images
  a = nonzeros(IBWroi);
  y(n) = mean2(a);
  
  % Filter out mean intensity of true color image for dark images (m < 100)
  if m(n) > 100
  % Filter out mean intesnity for range filtered images (y < 3.5)
  if y(n) > 3.5
      fprintf([listing(n).name '\n']);
      fprintf([n]);
       end
      end
  end

%% (4) Create vector of days based upon number of images per day
for i = 1:nFiles
    x(i) = i/24;
end

%% (5) Plot f
figure,plot(x,y); xlabel('Time (Days)'); ylabel('Mean RangeFilt Intensity');
figure,plot(x,m); xlabel('Time (Days)'); ylabel('Mean BW Image Intensity');

